//Very Tiny Game Pack 1
//version 1
//By Sparr
//(c) 2004 Clarence Risher
//sparr0@gmail.com
//Released under the GNU GPL, latest version available at http://www.gnu.org/licenses/gpl.txt

#define NO_AMS_CHECK
#define NO_CALC_DETECT
#include <tigcclib.h>
#undef __need_in_use_bit
#define __need_in_use_bit ((void)0)
#include "extgraph.h"

register unsigned short globalsprite asm("a4");
register short x1 asm("d4"),y1 asm("d5"),x2 asm("d6"), y2 asm("d7");

//--------------------------------------------------------------------------
//shared functions

void instructions(const char* string){
	clrscr();
	puts(string);
	ngetchx();
}

//XOR a screen pixel
void XORPix(unsigned short x,unsigned short y) {
	EXT_XORPIX(LCD_MEM,x,y);
}

//XOR a 4x4 sprite onto the display
void XORSprite(unsigned short x,unsigned short y,unsigned short sprite) {
	short sx,sy;
	for(sx=4;sx--;)
		for(sy=4;sy--;)
			if(((sprite<<(sy*4))<<sx)&(1<<15)) XORPix(x+sx,y+sy);
}

//check if a 4x4 sprite collides with something on the screen
int collide() {
	short sx;
	for(sx=15;sx--;)
		if(
			((globalsprite<<sx)&(1<<15))
			&&
			EXT_GETPIX(LCD_MEM,x1+sx%4,y1+sx/4)
		)
			return 1;
	return 0;
}

//Draw (or erase) the current sprite at the current location.
void XORPiece() {
	XORSprite(x1,y1,globalsprite);
}

void outline() {
	short x;
	for(x=160;x--;) {
		XORPix(x,0);
		XORPix(x,79);
	}
	for(x=80;x--;) {
		XORPix(0,x);
		XORPix(159,x);
	}
}

//rotate the top left 3x3 subsprite of ps num*90 degrees clockwise
//implemented as a full rotation, then bit shift left.
void squarerotate() {
	short ts=0,x,y;
	for(x=0;x<4;x++)
		for(y=0;y<4;y++)
			ts|=((globalsprite>>(y*4+x))&1)<<((x*4)+(3-y));
	globalsprite=ts<<1;
}
//--------------------------------------------------------------------------
#define WORMARRAYLENGTH 6000
#define WORMDIR globalsprite
short wormhighscore=0;
void worm(void)
{
	unsigned char fx,fy;
	short wormmaxlength;
	unsigned char (*wormpoints)[2];
	if(!(wormpoints=malloc(2*WORMARRAYLENGTH*sizeof(unsigned char)))) return;
	short x,timer;
	short speed=300;
	instructions("Worm\n\nCollect the dots without\nrunning into anything\n\nLEFT/RIGHT = Turn");
	start:
	x2=0;
	y2=0;
	wormmaxlength=32;
	WORMDIR=0;
	x1=80;
	y1=40;
	fx=80;
	fy=40;
	ClrScr();
	outline();
	XORSprite(fx,fy,0b1100110000000000);
	do {
		while((unsigned char)(x1-fx)<=1&&(unsigned char)(y1-fy)<=1) {
			XORSprite(fx,fy,0b1100110000000000);
			wormmaxlength=wormmaxlength*4/3;
			wormmaxlength=wormmaxlength>=WORMARRAYLENGTH-1?WORMARRAYLENGTH-2:wormmaxlength;
			fx=(fy+(*(unsigned char*)0x600017))%157+1;
			fy=(fy+(*(unsigned char*)0x600017))%77+1;
			XORSprite(fx,fy,0b1100110000000000);
		}
		wormhighscore=wormhighscore>wormmaxlength?wormhighscore:wormmaxlength;
		for(x=4,timer=1;x--;timer*=10) {
			DrawChar(x*6+80,91,((wormhighscore/timer)%10)+'0',A_REPLACE);
			DrawChar(x*6,91,((wormmaxlength/timer)%10)+'0',A_REPLACE);
		}
		if(EXT_GETPIX(LCD_MEM,x1,y1)) break;
		XORPix(x1,y1);
		x2--;
		x2=(x2+WORMARRAYLENGTH)%WORMARRAYLENGTH;
		wormpoints[x2][0]=x1;
		wormpoints[x2][1]=y1;
		if((y2-x2+WORMARRAYLENGTH)%WORMARRAYLENGTH>wormmaxlength) {
			y2--;
			y2=(y2+WORMARRAYLENGTH)%WORMARRAYLENGTH;
			XORPix(wormpoints[y2][0],wormpoints[y2][1]);
		}
		timer=speed;
		for(;timer--;) {
			if(kbhit()) {
				timer=0;
				switch (ngetchx()) {
					case KEY_LEFT:
						WORMDIR=(WORMDIR+1)%4; break;
					case KEY_RIGHT:
						WORMDIR=(WORMDIR+3)%4; break;
					case '+':
						speed=speed*3/4; break;
					case '-':
						speed=speed*4/3; break;
					case KEY_ESC:
						goto quit;
				}
			}
		}
		x1+=(!(WORMDIR&1))*(1-WORMDIR);
		y1+=(WORMDIR&1)*(WORMDIR-2);
	}while(1);
	if(DlgMessage("Game Over!","Play Again?",BT_YES,BT_NO)==KEY_ENTER)
		goto start;
	quit:
	free(wormpoints);
	return;
}
//--------------------------------------------------------------------------
short won;
long board;
unsigned short tttsprites[3]={0,0b0110100110010110,0b1001011001101001};
long tttpatterns[16]= \
{ \
//   POSITIONS
//   8 7 6 5 4 3 2 1 0
	0b111111111111010100,\
	0b111101111101111100,\
	0b011111110111111100,\
	0b111111111111010001,\
	0b110111110111110011,\
	0b111111111111101000,\
	0b111110111110111100,\
	0b101111111011111100,\
	0b111111111111100010,\
	0b111011111011110011,\
	0b000010000100100000,\
	0b111100110110001000,\
	0b111100110110100000,\
	0b111110110100100000,\
	0b001111111011111100,\
	0b110011111011110011};
void SETSprite(unsigned short x,unsigned short y,unsigned short sprite) {
	short sx,sy;
	for(sx=4;sx--;)
		for(sy=4;sy--;)
			if(((sprite<<(sy*4))<<sx)&(1<<15)) EXT_SETPIX(LCD_MEM,x+sx,y+sy);
}
void displayboard() {
	short n;
	for(n=9;n--;) {
		SETSprite((n%2)*7+2+71,(n/3)*7+8,0b0001000100010001);
		SETSprite((n%3)*7+71,(n%2)*7+2+8,0b0000000000001111);
		SETSprite((n%3)*7+71,(2-(n/3))*7+8,tttsprites[(board>>(n*2))&3]);
	}
}
void aimove() {
	short r,p,c,moved=0;
	++x1;
	for(c=0;c<16;c++) {
		for(r=0;r<4;r++) {
			if(!moved) {
				for(p=0;p<9;p++) {
					short bp=((board>>(p*2))&3);
					short pp=((tttpatterns[c]>>(p*2))&3);
					if(!(
						pp==3
						||
						bp==pp
					)) {
						break;
					}
				}
				if(p==9) {
					moved=1;
					won=(c<5);
					board|=0b01<<(((0b1000011100011000>>c)&1)*2);
				}
			}
			board=
			((board&0b11000000000000)>>(6*2))|
			((board&0b11000000)>>(2*2))|
			((board&0b11)<<(2*2))|
			((board&0b1100000000000000)>>(4*2))|
			((board&0b1100000000)<<(0*2))|
			((board&0b1100)<<(4*2))|
			((board&0b110000000000000000)>>(2*2))|
			((board&0b110000000000)<<(2*2))|
			((board&0b110000L)<<(6*2));
		}
	}
	if (!moved) {
		if(!((board>>8)&3)) {
			board|=0b0100000000;
			return;
		}
		for(p=0;p<9;p++) {
			if(!((board>>(p*2))&3)) {
				board|=0b01<<(p*2);
				return;
			}
		}
	}
}
void ttt(void)
{
	instructions("Tic Tac Toe\n\nTry for 3 in a row!\n\n1-9 = Move\n0   = Go Second");
	playagain:
	board=0;
	won=0;
	x1=0;
	ClrScr();
	unsigned short key=0;
	displayboard();
	do {
		if(key=='0'&&board==0)
			aimove();
		if(key-'1'<9&&!((board>>((key-'1')*2))&3)) {
			board|=0b10L<<((key-'1')*2);
			++x1;
			aimove();
		}
		if(key==KEY_ESC)
			goto quit;
		displayboard();
		if(won||x1>8) break;
	} while((key=ngetchx()));
	if(DlgMessage(won?"You Lose":"Tie","Play again?",BT_YES,BT_NO)==KEY_ENTER)
		goto playagain;
	quit:
	;
}
//--------------------------------------------------------------------------
#define SQUARELEFT 32
#define SQUARERIGHT 49
#define SQUARETOP 32
#define SQUAREBOTTOM 49

#define NUMPIECES 42

unsigned short squarepieces[NUMPIECES] = \
{ \
0b1110000000000000, \
0b0110010000000000, \
0b1110001000000000, \
0b1110100000000000, \
0b1110010000000000, \
0b0110110000000000, \
0b1100011000000000, \
0b1110110000000000, \
0b1110011000000000, \
0b1110100010000000, \
0b1110101000000000, \
0b0010111010000000, \
0b1000111010000000, \
0b0100111010000000, \
0b0100111000100000, \
0b1110111000000000, \
0b0010111011000000, \
0b0100111011000000, \
0b1000111011000000, \
0b1000111010100000, \
0b0100111010100000, \
0b0010111010100000, \
0b1000111001100000, \
0b0100111001100000, \
0b0010111001100000, \
0b1110101010000000, \
0b1000101011100000, \
0b1100100011100000, \
0b1110100011000000, \
0b1110110010000000, \
0b0010111011100000, \
0b1000111011100000, \
0b0100111011100000, \
0b0110011011100000, \
0b1100110011100000, \
0b0110111010100000, \
0b1100111010100000, \
0b0110111011000000, \
0b1010101011100000, \
0b0110111011100000, \
0b1010111011100000, \
0b1100111011100000 \
};
void square(void)
{

	char *virtual=malloc(LCD_SIZE);
	short x,y;

	instructions("Square\n\nArrange the pieces to\nform 3x3 or larger\nblocks.\n\nF1/F2 = Rotate\nF3    = Place");
	restart:

	ClrScr();
	
	for(x=SQUARERIGHT;x---(SQUARELEFT+1);) {
		XORPix(x,SQUARETOP);
		XORPix(x,SQUAREBOTTOM);
	}
	for(y=SQUAREBOTTOM;y---(SQUARETOP+1);) {
		XORPix(SQUARELEFT,y);
		XORPix(SQUARERIGHT,y);
	}
	
	//Main loop, make new piece, check for game over, display scores
	while(1){
		globalsprite=squarepieces[((globalsprite>>5)+(*(unsigned char*)0x600017))%NUMPIECES]; // somewhat random number
		x1=SQUARELEFT+1;
		y1=SQUARETOP+1;
		if(collide()) break;

		XORPiece();
		while(1) {
			if(kbhit()) {
				XORPiece();
				unsigned short key=ngetchx();
				if(key==KEY_RIGHT) {
					x1++;
				  x1-=collide();
				}
				if(key==KEY_LEFT) {
					x1--;
					x1+=collide();
				}
				if(key==KEY_UP) {
					y1--;
					y1+=collide();
				}
				if(key==KEY_DOWN)
					y1++;
					y1-=collide();
				if(key==KEY_F1) {
					squarerotate();
					squarerotate();
					squarerotate();
					if(collide()) squarerotate();
				}
				if(key==KEY_F2) {
					squarerotate();
					if(collide()) {
						squarerotate();
						squarerotate();
						squarerotate();
					}
				} 
				if(key==KEY_F3) {
					XORPiece();
					break;
				}
				if(key==KEY_ESC)
				  goto quit;
				XORPiece();
			}
		}

		for(x=LCD_SIZE;x--;)
			*(virtual+x)=0;

		for(x=SQUARELEFT+1;x<SQUARERIGHT-2;x++) {
			for(y=SQUARETOP+1;y<SQUAREBOTTOM-2;y++) {

				short s;
				for(s=9;s--;)
					if(!(EXT_GETPIX(LCD_MEM,x+s%3,y+s/3))) break;
				if(s==-1) 
					for(s=9;s--;)
						EXT_SETPIX(virtual,x+s%3,y+s/3);
			}
		}
		for(x=LCD_SIZE;x--;)
			*(char*)(LCD_MEM+x)^=*(virtual+x);
	}
	
	if(DlgMessage("Game Over","Play Again?",BT_YES,BT_NO)==KEY_ENTER)
		goto restart;

	quit:
	;
}
//--------------------------------------------------------------------------
#define TETRISLEFTSIDE 0
#define TETRISRIGHTSIDE 1
#define TETRISTOP 107
#define TETRISBOTTOM 126

//sprites for '0' and '1'
unsigned short binary[2] = {0b0100101010100100,0b0100110001001110};

//7 pieces, plus an extra T piece
//4 rotated copies of each piece
unsigned short tetrispieces[8]=
{ 
	0b0000000011110000,
	0b0000001011100000,
	0b0000111000100000,
	0b0000010011100000,
	0b0000011100100000,
	0b0000110001100000,
	0b0000011011000000,
	0b0000011001100000
};
//Draw (or erase) the piece at its location for tetris.
void XORPieceT() {
	//draw the piece on the tiny board
	XORSprite(x1,y1,globalsprite);
	short sx,sy;
	//calculate and maybe draw the position the piece will be in if you hit F1
	short dropy=y1;
	short redraw=0;
	if(collide()) {
		XORSprite(x1,y1,globalsprite);
		redraw=1;
	}
	while(!collide()&&y1<TETRISBOTTOM)
		y1++;
	y1--;
	short temp=y1;
	y1=dropy;
	XORSprite(x1,y1,globalsprite);
	y1=temp;
	if(!collide()&&y1<TETRISBOTTOM)
		for(sx=4;sx--;)
			for(sy=4;sy--;)
				if(((globalsprite<<(sy*4))<<sx)&(1<<15)) XORSprite(
				(x1+sx)*4+48,
				((y1-TETRISTOP)+sy)*4,
				0b1101100000011011);
	y1=dropy;
	XORSprite(x1,y1,globalsprite);
	if(redraw) {
		XORSprite(x1,y1,globalsprite);
	}

	//draw the piece on the big board
	for(sx=4;sx--;)
		for(sy=4;sy--;)
			if(((globalsprite<<(sy*4))<<sx)&(1<<15)) XORSprite(
			(x1+sx)*4+48,
		((y1-TETRISTOP)+sy)*4,
			0b1111110110111111);
}
void tetris(void)
{
	short timer,pn,npn;
	short delay=2000;
	
	short x,y;
	instructions("Tetris\n\nFill entire rows to\nmake them disappear\n\nLT/RT/DN = Move\nUP = Rotate\nF1 = Drop");
	ClrScr();
	
	for(x=TETRISLEFTSIDE*8+1;x<TETRISRIGHTSIDE*8+7;x++) {
		XORSprite(x*4+48,(TETRISBOTTOM-TETRISTOP)*4,0b1111101001011010);
		XORPix(x,TETRISBOTTOM);
	}
	for(y=TETRISTOP;y<=TETRISBOTTOM;y++) {
		XORSprite(0+48,(y-TETRISTOP)*4,0b0101101101011011);
		XORSprite(((TETRISRIGHTSIDE-TETRISLEFTSIDE+1)*8-1)*4+48,(y-TETRISTOP)*4,0b1010110110101101);
		XORPix(TETRISLEFTSIDE*8,y);
		XORPix(TETRISRIGHTSIDE*8+7,y);
	}
	
	while(1){
		pn=npn&7;
		npn=*(char*)0x600017; //pseudo-psuedo-random number
		globalsprite=tetrispieces[pn];
		x1=(TETRISLEFTSIDE*8)+((TETRISRIGHTSIDE*8+7)-(TETRISLEFTSIDE*8))/2-1;
		y1=TETRISTOP;
		if(collide()) break;

		for(x=121;--x;)
			*(((long *)LCD_MEM+750-x))=0;
//display your score, in binary, in the bottom right
		for(x=12;x--;)
			XORSprite(134-x*4,(LCD_HEIGHT-4),binary[((2000-delay)>>x)&1]);
//display the next piece on the bottom
	short sx,sy;
	for(sx=4;sx--;)
		for(sy=4;sy--;)
			if(((tetrispieces[npn&7]<<(sy*4))<<sx)&(1<<15)) XORSprite(
			(14+sx)*4,
			(22+sy)*4,
			0b1111110110111111);

		while(1){
			timer=delay*2;
			XORPieceT();
			while(timer>0) {
				timer--;
				if(kbhit()) {
					timer-=71;
					XORPieceT();
					unsigned short key=ngetchx();
					if(key==KEY_RIGHT) {
						x1++;
					  x1-=collide();
					}
					if(key==KEY_LEFT) {
						x1--;
						x1+=collide();
					}
					if(key==KEY_UP) {
					  squarerotate();
					  globalsprite>>=1;
					  x1-=collide();
					  x1+=collide()*2;
			  		if(collide()) {
			  			x1--;
						  squarerotate();
						  globalsprite>>=1;
						  squarerotate();
						  globalsprite>>=1;
						  squarerotate();
						  globalsprite>>=1;
			  		}
					}
					if(key==KEY_DOWN)
					  goto drop;
					if(key==KEY_F1) {
						do {
							y1++;
						} while(!collide());
						y1--;
						goto drop;
					}
					if(key==KEY_ESC)
					  goto quit;
					XORPieceT();
				}
			}
			XORPieceT();
			drop:
			y1++;
			if(collide()) {
				y1--;
				break;
			}
		}
		XORPieceT();
		for(y=(y1+3)>TETRISBOTTOM-1?TETRISBOTTOM-1:(y1+3);y>=y1;y--) {
			for(x=TETRISLEFTSIDE;x<=TETRISRIGHTSIDE;x++)
				if(*((char*)(LCD_MEM+y*30+x))!=~0) break;
			if(x==TETRISRIGHTSIDE+1) {
				memmove(LCD_MEM+TETRISTOP*30+30,LCD_MEM+TETRISTOP*30,(y-TETRISTOP)*30);
				memmove(LCD_MEM+4*30,LCD_MEM,(y-TETRISTOP)*4*30);
				y++;
				delay-=(TETRISRIGHTSIDE-TETRISLEFTSIDE)*8+6;
			}
		}
		delay--;
	}
	
	quit:
	;
}
//--------------------------------------------------------------------------
short troncollide() {
	return EXT_GETPIX(LCD_MEM,x1,y1)?1:EXT_GETPIX(LCD_MEM,x2,y2)?2:0;
}
void tron(void)
{
	short pad, pbd;
	short timer,keys;
	INT_HANDLER save_int_1, save_int_5;
	save_int_1 = GetIntVec (AUTO_INT_1);
	save_int_5 = GetIntVec (AUTO_INT_5);

	instructions("Tron\n\nDon't Crash!\n\nPlayer 1:\nF1,2nd,Shift,Diamond\n\nPlayer 2:\nArrows");
	restart:

	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
	SetIntVec (AUTO_INT_5, DUMMY_HANDLER);
	
	
	ClrScr();
	
	x1=20;
	y1=60;
	x2=140;
	y2=20;
	pad=0;
	pbd=2;

	outline();
	while(1){
		if(troncollide()) break;
		XORPix(x1,y1);
		XORPix(x2,y2);
		for(timer=1000;timer--;) {
			if((keys=_rowread(~0b100001))) {
				if((keys>>0)&1) {
					pbd=1;
				}
				if((keys>>1)&1) {
					pbd=2;
				}
				if((keys>>2)&1) {
					pbd=3;
				}
				if((keys>>3)&1) {
					pbd=0;
				}
				if((keys>>4)&1) {
					pad=2;
				}
				if((keys>>5)&1) {
					pad=0;
				}
				if((keys>>6)&1) {
					pad=3;
				}
				if((keys>>7)&1) {
					pad=1;
				}
			}
		}
		x1+=(!(pad&1))*(1-pad);
		y1+=(pad&1)*(pad-2);
		x2+=(!(pbd&1))*(1-pbd);
		y2+=(pbd&1)*(pbd-2);
	}

	SetIntVec (AUTO_INT_1, save_int_1);
	SetIntVec (AUTO_INT_5, save_int_5);

	if(DlgMessage(troncollide()-1?"Player 1 Wins":"Player 2 Wins","Play Again?",BT_YES,BT_NO)==KEY_ENTER)
		goto restart;
	
	return;	
}
//--------------------------------------------------------------------------
// Main Function
void _main(void)
{
	unsigned short a4=globalsprite,d4=x1,d5=y1,d6=x2,d7=y2;
	short oldOSInitKeyInitDelay=OSInitKeyInitDelay(96);
	short oldOSInitBetweenKeyDelay=OSInitBetweenKeyDelay(32);
	startover:
	clrscr();
	puts("Very Tiny Pack 1\n"
	     "By: Sparr\n\n"
	     "1: Square\n"
	     "2: Tetris\n"
	     "3: Tron (2 Players)\n"
	     "4: Tic Tac Toe\n"
	     "5: Worm\n\n"
	     "0: Exit"
	     );
	askagain:
	switch (ngetchx()-'0'){
		case 0:
			goto quit;
		case 1:
			square();
			break;
		case 2:
			tetris();
			break;
		case 3:
			tron();
			break;
		case 4:
			ttt();
			break;
		case 5:
			worm();
			break;
		default:
			goto askagain;
	}
	goto startover;
	quit:
	OSInitKeyInitDelay(oldOSInitKeyInitDelay);
	OSInitBetweenKeyDelay(oldOSInitBetweenKeyDelay); 
	globalsprite=a4;x1=d4;y1=d5;x2=d6;y2=d7;
}

